
#ifndef PACKET_H
#define PACKET_H

#include <inttypes.h>

int _preplace(const uint8_t * const src, const int len, uint8_t * const dst, const char * const needle, const char * const replace);

#define packet(number) (&pkt ## number[42])
#define psize(number) (sizeof(pkt ## number) - 42)
#define pmatch(b, number) (memcmp(b, packet(number), psize(number)) == 0)

#define preplace(src, dst, needle, replace) _preplace(packet(src), psize(src), dst, needle, replace)
#define pcopy(src, dst) _preplace(packet(src), psize(src), dst, NULL, NULL);

#define tacket(number) (&pkt ## number[54])
#define tsize(number) (sizeof(pkt ## number) - 54)
#define tmatch(b, number) (memcmp(b, tacket(number), psize(number)) == 0)

#define treplace(src, dst, needle, replace) _preplace(tacket(src), tsize(src), dst, needle, replace)
#define tcopy(src, dst) _preplace(tacket(src), tsize(src), dst, NULL, NULL);

#define hacket(number) ((unsigned char*)(strstr((char*)tacket(number), "\r\n\r\n")+4))
#define hsize(number) (tsize(number) - (hacket(number) - tacket(number)))
#define hmatch(b, number) (memcmp(b, hacket(number), hsize(number)) == 0)

#define hreplace(src, dst, needle, replace) _preplace(hacket(src), hsize(src), dst, needle, replace)
#define hcopy(src, dst) _preplace(hacket(src), hsize(src), dst, NULL, NULL);

#endif // PACKET_H

