
#ifndef MY_SELECT_H
#define MY_SELECT_H

typedef int  (*select_read_cb)(void * const ref,  const int fd);
typedef int  (*select_write_cb)(void * const ref, const int fd);
typedef void (*select_close_cb)(void * const ref, const int fd);

// enable read or write callback for specified slot index (returned by select_register)
void select_set_read_wanted(const int i, const int yes);
void select_set_write_wanted(const int i, const int yes);

// register read, write and/or except callback using select on a file
// descriptor, returns zero or positive slot index on succes or -1 on error
int select_register(const int fd, select_read_cb read_cb, select_write_cb write_cb, select_close_cb close_cb, void * const ref);

// drives the select system, returns after one wait, when no fd comes ready
// within usec_timeout it returns, returns 1 on succes or 0 on error
int select_tick(const int usec_timeout);

void select_init(void);

#endif // MY_SELECT_H

